#ifndef __BITMAP_H_INCLUDED__
#define __BITMAP_H_INCLUDED__

#define FILEHEADERSIZE 14					//եإåΥ
#define INFOHEADERSIZE 40					//إåΥ
#define HEADERSIZE (FILEHEADERSIZE+INFOHEADERSIZE)

typedef struct{
	unsigned char b;
	unsigned char g;
	unsigned char r;
}Rgb;

typedef struct{
	unsigned int h;
	unsigned char s;
	unsigned char v;
}Hsv;

typedef struct{
	unsigned int height;
	unsigned int width;
	Rgb *rgb;
	Hsv *hsv;
}Image;

//Хݥ󥿤ԤNULL֤
Image *Read_Bmp(char *filename);

//񤭹ߤ0Ԥ1֤
int Write_Bmp(char *filename, Image *img);

//ImageRGBwidth*heightʬưŪ˼롣
//Хݥ󥿤򡢼ԤNULL֤
Image *Create_Image(int width, int height);
//Imageˡ
void Free_Image(Image *img);

//fromtoRGB򥳥ԡ
void Imagecopy(Image *from, Image *to);

//RGBǡHSVǡѴ
void Rgb_to_Hsv(Image *img);

//HSVǡRGBǡѴ
void Hsv_to_Rgb(Image *img);

//HSVVФLaplacianfilterŬѡ0Ԥ1֤
//ѴβV(1-ratio):ratioΨˤ롣
int Hsvbrightlaplacian(Image *img, double ratio);

//HSVVФSobelfilterŬѡ0Ԥ1֤
//ѴβV(1-ratio):ratioΨˤ롣
int Hsvbrightsobel(Image *img, double ratio);

#endif /*__BITMAP_H_INCLUDED__*/
